/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _SHADOWMAP_H_
#define _SHADOWMAP_H_

#include "light.h"
#include "matrix4.h"
 
 
 
class ShadowMap
{
public:
	ShadowMap(int _width, int _height, int numTex);
	~ShadowMap();

	void setLight(LightSpot *spot);
	
    void beginUpdate(float near, float far);
    void endUpdate();
    void activate();
    void release();			
			
private:
	int width;
	int height;
    GLenum textureUnit;				  
	GLuint texId;	
    LightSpot* light;
			
    static Matrix4 scaleBiasMatrix;	
    Matrix4 sceneToLightMatrix;
};

#endif // _SHADOWMAP_H_
